#include <mutex>
#include <functional>
#include <map>

// ROS2
#include <rclcpp/rclcpp.hpp>
#include <{{ pkgname }}/srv/state.hpp>
#include <{{ pkgname }}/srv/transition.hpp>

// ROS1
#include <ros/ros.h>
#include <{{ pkgname }}/State.h>
#include <{{ pkgname }}/Transition.h>

class ResourceBridge : public rclcpp::Node
{
public:
   explicit ResourceBridge(const rclcpp::NodeOptions & options = rclcpp::NodeOptions())
  : Node("resource_bridge", options)
  {
    RCLCPP_DEBUG(this->get_logger(), "initializing resource bridge ROS2 server");
    {% for res in resources %}
    this->{{ res.name }}_get_srv_ = this->create_service<{{ pkgname }}::srv::State>("resource/get_{{ res.name }}",
      std::bind(&ResourceBridge::get_{{ res.name }}_state, this, std::placeholders::_1, std::placeholders::_2));
    this->{{ res.name }}_change_srv_ = this->create_service<{{ pkgname }}::srv::Transition>("resource/change_{{ res.name }}",
      std::bind(&ResourceBridge::change_{{ res.name }}_state, this, std::placeholders::_1, std::placeholders::_2));
    {% endfor %}
    RCLCPP_INFO(this->get_logger(), "server ready"); 
    ros::NodeHandle n; 
    {% for res in resources %}
    {{ res.name }}_get_srv_client_ = n.serviceClient<{{ pkgname }}::State>("resource/get_{{ res.name }}");
    {{ res.name }}_change_srv_client_ = n.serviceClient<{{ pkgname }}::Transition>("resource/change_{{ res.name }}");
    {% endfor %}
  }

  void connect() {
    RCLCPP_INFO(this->get_logger(), "connecting to ROS1 client");
    {% for res in resources %}
    {{ res.name }}_get_srv_client_.waitForExistence();
    {{ res.name }}_change_srv_client_.waitForExistence();
    {% endfor %}
    RCLCPP_INFO(this->get_logger(), "client ready");
  }

private:
  // Resources servers (ROS2)
  {% for res in resources %}
  rclcpp::Service<{{ pkgname }}::srv::State>::SharedPtr {{ res.name }}_get_srv_;
  rclcpp::Service<{{ pkgname }}::srv::Transition>::SharedPtr {{ res.name }}_change_srv_;
  {% endfor %}
  // Resources clients (ROS1)
  {% for res in resources %}
  ros::ServiceClient {{ res.name }}_get_srv_client_;
  ros::ServiceClient {{ res.name }}_change_srv_client_;
  {% endfor %}
  // Callbacks
  {% for res in resources %}
  void get_{{ res.name }}_state(const std::shared_ptr<{{ pkgname }}::srv::State::Request> request,
    std::shared_ptr<{{ pkgname }}::srv::State::Response> response) 
  {
    (void)request;
    RCLCPP_INFO(this->get_logger(), "get resource {{ res.name }} state");
    {{ pkgname }}::State srv;
    bool result = {{ res.name }}_get_srv_client_.call(srv);
    if (result) {
      RCLCPP_DEBUG_STREAM(this->get_logger(), "state: " << srv.response.state);
      response->state = srv.response.state;
    } else
      RCLCPP_WARN(this->get_logger(), "error getting resource {{ res.name }}");
  }
  void change_{{ res.name }}_state(const std::shared_ptr<{{ pkgname }}::srv::Transition::Request> request,
    std::shared_ptr<{{ pkgname }}::srv::Transition::Response> response) 
  {
    {{ pkgname }}::Transition srv;
    srv.request.target = request->target;
    {{ res.name }}_change_srv_client_.call(srv);
    response->success = srv.response.success;
    response->state = srv.response.state;
  }
  {% endfor %}

};

void spinThread()
{
  ros::spin();
}

int main(int argc, char ** argv)
{
  // ROS 2
  printf("Initializing ROS2\n");
  rclcpp::init(argc, argv);

  // ROS 1 node
  printf("Initializing ROS1 Node\n");
  ros::init(argc, argv, "resource_bridge");
  ros::NodeHandle ros1_node;

  // Bridge
  auto node = std::make_shared<ResourceBridge>();

  // ROS 1 asynchronous spinner
  ros::AsyncSpinner async_spinner(1);
  async_spinner.start();

  node->connect();

  // ROS 2 spinning loop
  rclcpp::executors::SingleThreadedExecutor executor;
  while (ros1_node.ok() && rclcpp::ok()) {
    executor.spin_node_once(node, std::chrono::milliseconds(100));
  }

  return 0;
}
